import urllib
import urllib2
import simplejson


_GOOGLE_URL = "http://ajax.googleapis.com/ajax/services/language/translate?v=1.0"
_GOOGLE_CHUNK_SIZE = 500 # Max num of characters that google API accepts


class InvalidLanguagePairError(Exception):
    pass


class ServiceUnavailableError(Exception):
    pass


def translate(src, langpair='se|en'):
    """Translate a word or sentance using google translate.

    'src' (string/unicode) is the word or sentance to translate.
    'langpair' is the languages to translate from and to. Use the format
    <src_lang>|<dst_lang>.

    Input is unicode or utf-8 encoded str. Returns unicode.
    """
    if isinstance(src, unicode):
        src = src.encode('utf-8')
    vars = [('q', src), ('langpair', langpair)]
    url = _GOOGLE_URL + '&' + urllib.urlencode(vars)
    response = urllib2.urlopen(url)
    json = simplejson.load(response)
    if json == None:
        raise ServiceUnavailableError, 'Sorry, translation service unavailable'
    elif json['responseStatus'] == 400:
        raise InvalidLanguagePairError, json['responseDetails']
    return unicode(json['responseData']['translatedText'])


def translate_plus(src, langpair='se|en'):
    """Like translate, but chops the input into sentances to avoid exceeding
    the Google Translate character limit.

    Input is unicode or utf-8 encoded str. Returns unicode.
    """
    dst = [translate(i.strip(), langpair) for i in src.split('.') if i != '']
    return u'. '.join(dst)
