#-*- coding: utf-8 -*-
import unittest
from unittest import TestSuite
from valentine.gtranslate import translate, translate_plus
from base import GTranslateTestCase


class GTranslateTestCase(GTranslateTestCase):

    def test_translate(self):
        src = u'Hej värld'
        dst = translate(src)
        self.assertEquals(dst != src, True)
        self.assertEquals(len(dst.split(' ')), len(src.split(' ')))

    def test_translate_plus(self):
        src = u"Denna sträng är så lång att Google translate inte kan ta den i ett " \
              u"enda stycke. Därför styckar vi upp den i meningar. " \
              u"\n\n" * 10
        src = src.strip()
        dst = translate_plus(src)
        self.assertEquals(dst != src, True)
        self.assertEquals(len(dst.split('.')), len(src.split('.')) - 1)


def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(GTranslateTestCase('test_translate'))
    suite.addTest(GTranslateTestCase('test_translate_plus'))
    return suite
